Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP.Cli/Program.cs	(revision 14513)
@@ -5,86 +5,203 @@
 using HeuristicLab.Algorithms.PushGP.Generators;
 using HeuristicLab.Algorithms.PushGP.Interpreter;
-
-namespace HeuristicLab.Algorithms.PushGP.Cli
-{
-    class Program
-    {
-        static void Main(string[] args)
-        {
-            SimpleTest();
-            //Stepwise().Wait();
-            //PerformanceTestInterpreter();
-            //PerformanceTestCodeGenerator();
-
-            Console.WriteLine("\nPress any key to continue...");
-            Console.ReadKey();
-        }
-
-        static void SimpleTest()
-        {
-            var interpreter = new PushGPInterpreter();
-
-            interpreter.Interpret("5 INTEGER.DUP INTEGER.+");
-
-            interpreter.PrintStacks();
-        }
-
-        static async Task Stepwise()
-        {
-            var interpreter = new PushGPInterpreter();
-
-            interpreter.InterpretAsync("( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )", true).Wait();
-
-            while (!interpreter.IsCompleted)
-            {
-                Console.Clear();
-                interpreter.PrintStacks();
-                interpreter.Step();
-
-                var input = Console.ReadKey();
-                if (input.Key == ConsoleKey.Escape)
-                {
-                    break;
-                }
-                else if (input.Key == ConsoleKey.Spacebar)
-                {
-                    await interpreter.ResumeAsync();
-                }
-            }
-
-            Console.Clear();
-            interpreter.PrintStacks();
-        }
-
-        static void PerformanceTestInterpreter()
-        {
-            var program = PushGPInterpreter.Encode("( 5 INTEGER.DUP INTEGER.+ )");
-            var interpreter = new PushGPInterpreter();
-            var sw = new Stopwatch();
-
-            sw.Start();
-            for (var i = 0; i < 20000000; i++)
-            {
-                interpreter.Interpret(program);
-                interpreter.Clear();
-            }
-            sw.Stop();
-
-            Console.WriteLine(sw.Elapsed);
-        }
-
-        static void PerformanceTestCodeGenerator()
-        {
-            var sw = new Stopwatch();
-
-            var interpreter = new PushGPInterpreter();
-            var generator = new CodeGenerator(interpreter);
-
-            sw.Start();
-            var expressions = generator.RandomCode(3000000);
-            sw.Stop();
-
-            Console.WriteLine(string.Format("Generated {0} in {1}", expressions.Count(), sw.Elapsed));
-        }
-    }
+using HeuristicLab.Algorithms.PushGP.Parser;
+
+namespace HeuristicLab.Algorithms.PushGP.Cli {
+
+  using HeuristicLab.Algorithms.PushGP.Data.Random;
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+  using HeuristicLab.Algorithms.PushGP.Simplifier;
+
+  class Program {
+    static void Main(string[] args) {
+      //SimpleTest();
+      //Stepwise().Wait();
+      //PerformanceTestInterpreter();
+      //PerformanceParallelTestInterpreter();
+      //PerformanceTestCodeGenerator();
+      TestRobustness();
+      //TestPool();
+      //TestPoolPerformance();
+      //TestSimplifier();
+
+      Console.WriteLine("\nPress any key to continue...");
+      Console.ReadKey();
+    }
+
+    static void SimpleTest() {
+      var interpreter = new PushGpInterpreter();
+
+      interpreter.Interpret("5 INTEGER.DUP INTEGER.+");
+
+      interpreter.PrintStacks();
+    }
+
+    static async Task Stepwise() {
+      var interpreter = new PushGpInterpreter();
+
+      interpreter.InterpretAsync("( 0 2 CODE.QUOTE ( 1 INTEGER.+ 0 3 CODE.QUOTE ( 1 INTEGER.+ INTEGER.* ) CODE.DO*RANGE INTEGER.+ ) CODE.DO*RANGE )", true).Wait();
+
+      while (!interpreter.IsCompleted) {
+        Console.Clear();
+        interpreter.PrintStacks();
+        interpreter.Step();
+
+        var input = Console.ReadKey();
+        if (input.Key == ConsoleKey.Escape) {
+          break;
+        } else if (input.Key == ConsoleKey.Spacebar) {
+          await interpreter.ResumeAsync();
+        }
+      }
+
+      Console.Clear();
+      interpreter.PrintStacks();
+    }
+
+    static void PerformanceTestInterpreter() {
+      var program = PushGPParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
+
+      var interpreter = new PushGpInterpreter();
+      var sw = new Stopwatch();
+
+      sw.Start();
+      for (var i = 0; i < 60000000; i++) {
+        interpreter.Interpret(program);
+        interpreter.Clear();
+      }
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+    }
+
+    static void PerformanceParallelTestInterpreter() {
+      var program = PushGPParser.Parse("( 5 INTEGER.DUP INTEGER.+ )");
+      //var program = new ExecExpandExpression(new Expression[]
+      //{
+      //  new IntegerPushExpression(5),
+      //  new IntegerDuplicateExpression(),
+      //  new IntegerAddExpression()
+      //});
+
+      var sw = new Stopwatch();
+      var iterations = 100;
+      var amount = 600000;
+      var pool = new PushGpInterpreterPool(iterations);
+
+      sw.Start();
+      Parallel.For(0, iterations, i => {
+        using (var interpreter = pool.GetInstance()) {
+
+          for (var j = 0; j < amount; j++) {
+            interpreter.Interpret(program);
+            interpreter.Clear();
+          }
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+    }
+
+    static void PerformanceTestCodeGenerator() {
+      var sw = new Stopwatch();
+
+      sw.Start();
+      var expressions = CodeGenerator.RandomCode(3000000);
+      sw.Stop();
+
+      Console.WriteLine(string.Format("Generated {0} in {1}", expressions.Count(), sw.Elapsed));
+    }
+
+    static void TestRobustness() {
+      var sw = new Stopwatch();
+      var parallism = Environment.ProcessorCount;
+      var maxProgramSizeLimit = 100;
+      var partitionSize = 100000;
+      RandomFactory.Seed = 1337;
+
+      var execCounters = new int[parallism];
+      var config = new Configuration { EvalPushLimit = 500 };
+      var pool = new PushGpInterpreterPool(config);
+
+      sw.Start();
+      Parallel.For(0, parallism, i => {
+        using (var interpreter = pool.GetInstance()) {
+          for (var j = 0; j < partitionSize; j++) {
+            var program = CodeGenerator.RandomProgram(maxProgramSizeLimit);
+
+            interpreter.Interpret(program);
+
+            execCounters[i] += interpreter.ExecCounter;
+            interpreter.Clear();
+          }
+        }
+      });
+      sw.Stop();
+
+      Console.WriteLine("ExecCount: {0}", execCounters.Sum());
+      Console.WriteLine("Duration: {0}", sw.Elapsed);
+    }
+
+    static void TestPool() {
+      var pool = new PushGpInterpreterPool();
+      var normal = new PushGpInterpreter();
+      int id;
+
+      using (var interpreter = pool.GetInstance()) {
+        interpreter.Interpret("( 1 2 INTEGER.+ )");
+
+        id = interpreter.GetHashCode();
+        if (id == normal.GetHashCode()) Console.WriteLine("equal 1");
+      }
+
+      using (var interpreter = pool.GetInstance())
+      using (var interpreter2 = pool.GetInstance()) {
+        interpreter.Interpret("( 1 2 INTEGER.+ )");
+        if (id == interpreter.GetHashCode()) Console.WriteLine("equal 2");
+        if (id == interpreter2.GetHashCode()) Console.WriteLine("equal 3");
+      }
+    }
+
+    static void TestPoolPerformance() {
+      var sw = new Stopwatch();
+      var iterations = 100000000;
+
+      sw.Start();
+      for (var i = 0; i < iterations; i++) {
+        var interpreter = new PushGpInterpreter();
+        interpreter.Clear();
+      }
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+
+      var pool = new PushGpInterpreterPool();
+      sw.Restart();
+      for (var i = 0; i < iterations; i++) {
+        using (var interpreter = pool.GetInstance()) {
+          interpreter.Clear();
+        }
+      }
+      sw.Stop();
+
+      Console.WriteLine(sw.Elapsed);
+    }
+
+    static void TestSimplifier() {
+      var interpreter = new PushGpInterpreter();
+      var program = PushGPParser.Parse("( 5 INTEGER.DUP FLOAT.+ INTEGER.+ )") as ExecExpandExpression;
+      var simplifier = new RandomSimplifier() { Trys = 10 };
+
+      var simplerProgram = simplifier.Simplify(
+        program,
+        solution => {
+          interpreter.Clear();
+          interpreter.Interpret(solution);
+          return interpreter.IntegerStack.Top == 10;
+        });
+
+      Console.WriteLine(simplerProgram);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/IRecyclable.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/IRecyclable.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/IRecyclable.cs	(revision 14513)
@@ -0,0 +1,5 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Data.Pool {
+  public interface IRecyclable {
+    void Recycle();
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/ObjectPool.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/ObjectPool.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Pool/ObjectPool.cs	(revision 14513)
@@ -0,0 +1,106 @@
+﻿// Licensed to the .NET Foundation under one or more agreements.
+// The .NET Foundation licenses this file to you under the MIT license.
+// See the LICENSE file in the project root for more information.
+
+using System;
+
+namespace HeuristicLab.Algorithms.PushGP.Data.Pool {
+  using System.Threading;
+
+  /// <summary>
+  /// Generic implementation of object pooling pattern with predefined pool size limit. The main
+  /// purpose is that limited number of frequently used objects can be kept in the pool for
+  /// further recycling.
+  ///
+  /// Notes:
+  /// 1) it is not the goal to keep all returned objects. Pool is not meant for storage. If there
+  ///    is no space in the pool, extra returned objects will be dropped.
+  ///
+  /// 2) it is implied that if object was obtained from a pool, the caller will return it back in
+  ///    a relatively short time. Keeping checked out objects for long durations is ok, but
+  ///    reduces usefulness of pooling. Just new up your own.
+  ///
+  /// Not returning objects to the pool in not detrimental to the pool's work, but is a bad practice.
+  /// Rationale:
+  ///    If there is no intent for reusing the object, do not use pool - just use "new".
+  /// </summary>
+  internal sealed class ObjectPool<T> where T : class, IRecyclable {
+    private struct Element {
+      internal T Value;
+    }
+
+    // storage for the pool objects.
+    private readonly Element[] _items;
+
+    // factory is stored for the lifetime of the pool. We will call this only when pool needs to
+    // expand. compared to "new T()", Func gives more flexibility to implementers and faster
+    // than "new T()".
+    private readonly Func<T> _factory;
+
+
+    internal ObjectPool(Func<T> factory)
+        : this(factory, Environment.ProcessorCount * 2) { }
+
+    internal ObjectPool(Func<T> factory, int size) {
+      _factory = factory;
+      _items = new Element[size];
+    }
+
+    private T CreateInstance() {
+      var inst = _factory();
+      return inst;
+    }
+
+    /// <summary>
+    /// Produces an instance.
+    /// </summary>
+    /// <remarks>
+    /// Search strategy is a simple linear probing which is chosen for it cache-friendliness.
+    /// Note that Free will try to store recycled objects close to the start thus statistically
+    /// reducing how far we will typically search.
+    /// </remarks>
+    internal T Allocate() {
+      var items = _items;
+      T inst;
+
+      for (int i = 0; i < items.Length; i++) {
+        // Note that the read is optimistically not synchronized. That is intentional.
+        // We will interlock only when we have a candidate. in a worst case we may miss some
+        // recently returned objects. Not a big deal.
+        inst = items[i].Value;
+        if (inst != null) {
+          if (inst == Interlocked.CompareExchange(ref items[i].Value, null, inst)) {
+            inst.Recycle();
+            goto gotInstance;
+          }
+        }
+      }
+
+      inst = CreateInstance();
+      gotInstance:
+
+      return inst;
+    }
+
+    /// <summary>
+    /// Returns objects to the pool.
+    /// </summary>
+    /// <remarks>
+    /// Search strategy is a simple linear probing which is chosen for it cache-friendliness.
+    /// Note that Free will try to store recycled objects close to the start thus statistically
+    /// reducing how far we will typically search in Allocate.
+    /// </remarks>
+    internal void Free(T obj) {
+      var items = _items;
+      for (int i = 0; i < items.Length; i++) {
+        if (items[i].Value == null) {
+          // Intentionally not using interlocked here.
+          // In a worst case scenario two objects may be stored into same slot.
+          // It is very unlikely to happen and will only mean that one of the objects will get collected.
+          items[i].Value = obj;
+          break;
+        }
+      }
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Random/RandomFactory.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Random/RandomFactory.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Random/RandomFactory.cs	(revision 14513)
@@ -0,0 +1,21 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Data.Random {
+  using System;
+  using System.Threading;
+
+  using HeuristicLab.Core;
+  using HeuristicLab.Random;
+
+  public class RandomFactory {
+    public static readonly RandomFactory Instance = new RandomFactory();
+
+    static RandomFactory() {
+      Seed = Environment.TickCount;
+    }
+
+    public static int Seed;
+
+    public static ThreadLocal<IRandom> GetRandom() {
+      return new ThreadLocal<IRandom>(() => new FastRandom(Seed/*Interlocked.Increment(ref Seed)*/));
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Tree/ExpressionNode.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Tree/ExpressionNode.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Tree/ExpressionNode.cs	(revision 14513)
@@ -0,0 +1,22 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Data {
+  using System.Collections.Generic;
+
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+
+  public class ExpressionNode {
+    public ExpressionNode(Expression expression) {
+      this.Expression = expression;
+    }
+
+    public Expression Expression { get; set; }
+    public IList<ExpressionNode> Children { get; set; }
+
+    public static ExpressionNode CreateNode(Expression expression) {
+      var node = new ExpressionNode(expression);
+
+
+
+      return node;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Tree/ExpressionTree.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Tree/ExpressionTree.cs	(revision 14513)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Data/Tree/ExpressionTree.cs	(revision 14513)
@@ -0,0 +1,18 @@
+﻿namespace HeuristicLab.Algorithms.PushGP.Data {
+  using HeuristicLab.Algorithms.PushGP.Expressions;
+
+  public class ExpressionTree {
+    public ExpressionNode Root { get; set; }
+
+    public static ExpressionTree BuildTree(ExecExpandExpression program)
+    {
+      var tree = new ExpressionTree { Root = new ExpressionNode(program) };
+
+      for (var i = program.Expressions.Count - 1; i >= 0; i--) {
+        tree.Root.Children.Add(ExpressionNode.CreateNode(program.Expressions[i]));
+      }
+
+      return tree;
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Exporter/Exporter.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Exporter/Exporter.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Exporter/Exporter.cs	(revision 14513)
@@ -1,12 +1,12 @@
-﻿using HeuristicLab.Algorithms.PushGP.Expressions;
+﻿namespace HeuristicLab.Algorithms.PushGP.Exporter
+{
+  using HeuristicLab.Algorithms.PushGP.Expressions;
 
-namespace HeuristicLab.Algorithms.PushGP.Exporter
-{
-    public static class Exporter
+  public static class Exporter
+  {
+    public static string ToString(Expression expression)
     {
-        public static string ToString(Expression expression)
-        {
-            return expression.ToString();
-        }
+      return expression.ToString();
     }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/BooleanExpressions.cs	(revision 14513)
@@ -1,85 +1,76 @@
-﻿using HeuristicLab.Algorithms.PushGP.Interpreter;
+﻿namespace HeuristicLab.Algorithms.PushGP.Expressions {
+  using HeuristicLab.Algorithms.PushGP.Interpreter;
 
-namespace HeuristicLab.Algorithms.PushGP.Expressions
-{
-    /// <summary>
-    /// Pushes the logical AND of the top two BOOLEANs.
-    /// </summary>
-    public class BooleanAndExpression : PushResultExpression<bool>
-    {
-        protected override string InitStringRepresentation()
-        {
-            return "BOOLEAN.AND";
-        }
-
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, 2, values => values[0] && values[1]);
-        }
+  /// <summary>
+  ///     Pushes the logical AND of the top two BOOLEANs.
+  /// </summary>
+  public class BooleanAndExpression : PushResultExpression<bool> {
+    protected override string InitStringRepresentation() {
+      return "BOOLEAN.AND";
     }
 
-    /// <summary>
-    /// Pushes the logical OR of the top two BOOLEANs.
-    /// </summary>
-    public class BooleanOrExpression : PushResultExpression<bool>
-    {
-        protected override string InitStringRepresentation()
-        {
-            return "BOOLEAN.OR";
-        }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.BooleanStack, 2, values => values[0] && values[1]);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, 2, values => values[0] || values[1]);
-        }
+  /// <summary>
+  ///     Pushes the logical OR of the top two BOOLEANs.
+  /// </summary>
+  public class BooleanOrExpression : PushResultExpression<bool> {
+    protected override string InitStringRepresentation() {
+      return "BOOLEAN.OR";
     }
 
-    /// <summary>
-    /// Pushes the logical NOT of the top BOOLEAN.
-    /// </summary>
-    public class BooleanNotExpression : PushResultExpression<bool>
-    {
-        protected override string InitStringRepresentation() { return "BOOLEAN.NOT"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.BooleanStack, 2, values => values[0] || values[1]);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            Eval(interpreter.BooleanStack, 1, values => !values[0]);
-        }
+  /// <summary>
+  ///     Pushes the logical NOT of the top BOOLEAN.
+  /// </summary>
+  public class BooleanNotExpression : PushResultExpression<bool> {
+    protected override string InitStringRepresentation() {
+      return "BOOLEAN.NOT";
     }
 
-    /// <summary>
-    /// Pushes FALSE if the top FLOAT is 0.0, or TRUE otherwise.
-    /// </summary>
-    public class BooleanFromFloatExpression : StatelessExpression
-    {
-        protected override string InitStringRepresentation() { return "BOOLEAN.FROMFLOAT"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      this.Eval(interpreter.BooleanStack, 1, values => !values[0]);
+    }
+  }
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            if (interpreter.FloatStack.Count == 0)
-                return;
-
-            var value = interpreter.FloatStack.Pop() != 0.0;
-
-            interpreter.BooleanStack.Push(value);
-        }
+  /// <summary>
+  ///     Pushes FALSE if the top FLOAT is 0.0, or TRUE otherwise.
+  /// </summary>
+  public class BooleanFromFloatExpression : StatelessExpression {
+    protected override string InitStringRepresentation() {
+      return "BOOLEAN.FROMFLOAT";
     }
 
-    /// <summary>
-    /// Pushes FALSE if the top INTEGER is 0, or TRUE otherwise.
-    /// </summary>
-    public class BooleanFromIntegerExpression : StatelessExpression
-    {
-        protected override string InitStringRepresentation() { return "BOOLEAN.FROMINTEGER"; }
+    public override void Eval(IPushGpInterpreter interpreter) {
+      if (interpreter.FloatStack.Count == 0) return;
 
-        public override void Eval(IInterpreter interpreter)
-        {
-            if (interpreter.IntegerStack.Count == 0)
-                return;
+      var value = interpreter.FloatStack.Pop() != 0.0;
 
-            var value = interpreter.IntegerStack.Pop() != 0;
+      interpreter.BooleanStack.Push(value);
+    }
+  }
 
-            interpreter.BooleanStack.Push(value);
-        }
+  /// <summary>
+  ///     Pushes FALSE if the top INTEGER is 0, or TRUE otherwise.
+  /// </summary>
+  public class BooleanFromIntegerExpression : StatelessExpression {
+    protected override string InitStringRepresentation() {
+      return "BOOLEAN.FROMINTEGER";
     }
+
+    public override void Eval(IPushGpInterpreter interpreter) {
+      if (interpreter.IntegerStack.Count == 0) return;
+
+      var value = interpreter.IntegerStack.Pop() != 0;
+
+      interpreter.BooleanStack.Push(value);
+    }
+  }
 }
Index: /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/CodeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/CodeExpressions.cs	(revision 14512)
+++ /branches/PushGP/HeuristicLab.Algorithms.PushGP/HeuristicLab.Algorithms.PushGP/Expressions/CodeExpressions.cs	(revision 14513)
@@ -1,8 +1,3 @@
-﻿using System;
-using System.Collections.Generic;
-using System.Linq;
-using HeuristicLab.Algorithms.PushGP.Interpreter;
-
-/// <summary>
+﻿/// <summary>
 /// For explicit code manipulation and execution. May also be used as a general list data type.
 /// This type must always be present, as the top level interpreter will push any code to be executed on the
